package com.logopartner.customization;

import com.lbs.batch.BatchOperationBase;
import com.lbs.data.database.DBConnection;
import com.lbs.data.database.DBConnectionPool;
import com.lbs.data.export.CustomObjectFactory;
import com.lbs.data.factory.FactoryParams;
import com.lbs.data.factory.ServerObjectFactory;
import com.lbs.data.objects.BasicBusinessObject;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.data.query.IQueryFactory;
import com.lbs.data.query.QueryBusinessObjects;
import com.lbs.data.query.QueryParams;
import com.lbs.data.query.ServerQueryFactory;
import com.logopartner.util.ProjectGlobals;

public class BatchDoctorUpdate extends BatchOperationBase {

	private QueryParams paramsSelect = new QueryParams();
	public int run() {
		
		IQueryFactory serverFactory = null;
		ServerObjectFactory custObjFactory = null;
		ServerObjectFactory factory = null;
		DBConnection connection = null; connection = null;
		
		try {
			serverFactory = getQueryFactory();
			QueryBusinessObjects templates = new QueryBusinessObjects();
			
			//may fill params with required parameters
			
			int VATNUMOFRECS = 100;
			serverFactory.first(ProjectGlobals.getProjectGUID() + ".DoctorBrowser", paramsSelect, templates, VATNUMOFRECS, false);
			for(int i = 0 ; i < templates.size() ; i++){
				BasicBusinessObject template = (BasicBusinessObject) templates.get(i);
				System.out.println(template.getProperties().get("CODE")+" "+template.getProperties().get("NAME")+" "+template.getProperties().get("SURNAME"));
			}
			
			connection = DBConnectionPool.getConnection();
			custObjFactory = new ServerObjectFactory(connection);
			
			CustomBusinessObject detay = new CustomBusinessObject(ProjectGlobals.getProjectGUID(), "BODoctor");
			FactoryParams fparams = new FactoryParams();
			fparams.setActiveFilter("LOGICALREF = 1");
			
			custObjFactory.first(detay, fparams);
			detay.set("CODE", "5555");
			detay.set("NAME", "Hasan");
			detay.set("SURNAME", "L");

			FactoryParams params = new FactoryParams();
			custObjFactory.persist(detay, params);
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally{
			if (factory != null)
				DBConnectionPool.releaseObjectFactory(custObjFactory);
		}
		return 0;
	}
	
	public int setParams(Integer i) 
	{
		return 0;
	}

}
