package com.logopartner.customization;

import java.awt.Point;
import java.awt.Rectangle;

import com.lbs.xui.JLbsXUILookupInfo;
import com.lbs.xui.JLbsXUITypes;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.lbs.controls.JLbsControlHelper;
import com.lbs.controls.maskededit.JLbsTextEdit;
import com.lbs.data.objects.CustomBusinessObject;
import com.logopartner.util.FormUtil;
import com.logopartner.util.ProjectUtil;
import com.lbs.controls.JLbsComboEdit;

public class ExaminationEditHandler
{
	public JLbsTextEdit editPatName;
	public JLbsComboEdit cmbDoctor;

	public void onInitialize(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject bo = (CustomBusinessObject) event.getData();
			CustomBusinessObject pat = (CustomBusinessObject) bo.get("Patient");
			if (pat != null)
			{
				String fullName = pat.get("NAME") + " " + pat.get("SURNAME");
				if (editPatName != null)
					editPatName.setText(fullName);
			}
		}
		catch (Exception e)
		{
		}
	}

	public void onKeyPressed(JLbsXUIControlEvent event)
	{
		FormUtil.checkForComboClear(event, "Examination.DOCTORREF", "Examination.Doctor", 210);
	}

	public void onDoctorLookup(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject visit = (CustomBusinessObject) event.getData();			
			CustomBusinessObject codeObj = (CustomBusinessObject) ProjectUtil.getMemberValue(visit, "Examination.Doctor");
			if (codeObj == null)
				codeObj = new CustomBusinessObject();
			JLbsXUILookupInfo lookup = new JLbsXUILookupInfo();
			Rectangle r = JLbsControlHelper.getRootCoordinates(cmbDoctor);
			FormUtil.displayBrowser(event.getClientContext(), event.getContainer(), 
            		"Forms/DoctorBrowser.lfrm", lookup, new Point(r.x, r.y + r.height), true);
            if (lookup.getIntegerData("LOGICALREF") != 0)
            {
            	event.getContainer().setModified(true);
            	ProjectUtil.setMemberValue(visit, "Examination.DOCTORREF", lookup.getLookupData("LOGICALREF"));
            	codeObj.set("CODE", lookup.getStringData("CODE"));
            	codeObj.set("NAME", lookup.getStringData("NAME"));
            	codeObj.set("SURNAME", lookup.getStringData("SURNAME"));
            	ProjectUtil.setMemberValue(visit, "Examination.Doctor", codeObj);
            	FormUtil.updateComponentData(event.getContainer(), 210);
            	FormUtil.updateComponentData(event.getContainer(), 211);
            	FormUtil.updateComponentData(event.getContainer(), 212);
            }			
		} 
		catch (Exception e)
		{
		}
	}

	public void onTestBtnClick(JLbsXUIControlEvent event)
	{
        try
        {
        	CustomBusinessObject visit = (CustomBusinessObject) event.getData();
        	CustomBusinessObject diag = (CustomBusinessObject) visit.get("Examination");
        	if (diag == null)
        	{
        		diag = FormUtil.createCustomObject("BOExamination");
        		visit.set("Examination", diag);
        	}
        	if (FormUtil.displayForm(event.getClientContext(), event.getContainer(), 
        			"Forms/AnalysisEdit.lfrm", diag, true) == JLbsXUITypes.XUIOP_PERSISTED)
        	{
        		event.getContainer().setModified(true);
				ProjectUtil.warn(event, "The patient analysis has been collected.");
				return;
        	}
        }
        catch (Exception ex)
        {
        }		
	}
}
