package com.logopartner.util;

import com.lbs.data.grids.JLbsQueryGrid;
import com.lbs.data.objects.BusinessObject;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.data.objects.CustomBusinessObjects;
import com.lbs.data.query.QueryBusinessObject;
import com.lbs.data.query.QueryBusinessObjects;
import com.lbs.mi.defs.ModuleAction;
import com.lbs.util.QueryUtil;
import com.lbs.xui.JLbsXUIPane;
import com.lbs.xui.JLbsXUITypes;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.lbs.xui.customization.JLbsXUIModuleActionEvent;

public class RECFHireBHandler
{
	public static JLbsQueryGrid grid;
	public static int f_Status;

	public RECFHireBHandler()
	{
		super();
		// TODO Auto-generated constructor stub
	}

	public void onModifyModuleAction(JLbsXUIModuleActionEvent event)
	{
		ModuleAction action = event.getModuleAction();

		try
		{
			action.setDataClass("#lookup");

			action.setParamValues(ProjectUtil.formListArray(new String[]
			{ "LOInvoiceType" }, new Object[]
			{ new Integer(2) }));
			action.setQueryParamValues(ProjectUtil.formListArray(new String[]
			{ "P_GROUPCODE", "P_SLIPTYPE", "P_RETYPE" }, new Object[]
			{ new Integer(2), new Integer(9), new Integer(25) }));
			event.setReturnObject(action);

		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void onInitialize(JLbsXUIControlEvent event)
	{
		// ProjectUtil.showFormParameters(event);
	}

	public void onStatusBTNClick(JLbsXUIControlEvent event)
	{
		JLbsXUIPane container = event.getContainer();

		JLbsQueryGrid grid = (JLbsQueryGrid) container.getComponentByTag(100);
		QueryBusinessObject slrow = (QueryBusinessObject) grid
				.getSelectedObject();
		int myRef = QueryUtil.getIntProp(slrow, "Reference");
				
		BusinessObject editBO = (BusinessObject) container.getData();
		CustomBusinessObject editCBO = (CustomBusinessObject) ProjectUtil
				.checkAndCreateNewCBO(editBO, "RECOHire");

		CustomBusinessObject hireobj = (CustomBusinessObject) ProjectUtil
				.readObject(event, "LOBOInvoice", myRef);

		f_Status = QueryUtil.getIntProp(slrow, "STATUS2");

		container.openChild("Forms/RECFApprovalH.lfrm", hireobj, true,
				JLbsXUITypes.XUIMODE_DBUPDATE);

	}

	public void onPopupMenuAction(JLbsXUIControlEvent event)
	{
		if (event.getIndex() == 129)
		{
			JLbsXUIPane container = event.getContainer();

			JLbsQueryGrid grid = (JLbsQueryGrid) container
					.getComponentByTag(100);
			QueryBusinessObject slrow = (QueryBusinessObject) grid
					.getSelectedObject();
			int myRef = QueryUtil.getIntProp(slrow, "Reference");

			CustomBusinessObject hireObj = (CustomBusinessObject) ProjectUtil
					.readObject(event, "LOBOInvoice", myRef);
			if (hireObj != null)
			{
				ProjectUtil.checkAndCreateNewCBO(hireObj, "RECOHire");
			}

			f_Status = QueryUtil.getIntProp(slrow, "STATUS2");

			container.openChild("Forms/RECFApprovalH.lfrm", hireObj, true,
					JLbsXUITypes.XUIMODE_DBUPDATE);
		}
	}

	public void onMenuAction(JLbsXUIControlEvent event)
	{

		if (event.getIndex() == 333)
		{
			JLbsXUIPane container = event.getContainer();

			JLbsQueryGrid grid = (JLbsQueryGrid) container
					.getComponentByTag(100);
			QueryBusinessObject slrow = (QueryBusinessObject) grid
					.getSelectedObject();
			int myRef = QueryUtil.getIntProp(slrow, "LOGICALREF");

			CustomBusinessObject demandobj = (CustomBusinessObject) ProjectUtil
					.readObject(event, "RECOHire", myRef);

			CustomBusinessObjects DocLinkObjects = (CustomBusinessObjects) ProjectUtil
					.getMemberValue(demandobj, "DocLink");
			if (DocLinkObjects == null)
			{
				DocLinkObjects = new CustomBusinessObjects();
				ProjectUtil
						.setMemberValue(demandobj, "DocLink", DocLinkObjects);
			}
			if (DocLinkObjects != null && DocLinkObjects.size() == 0)
			{
				String[] params = new String[]
				{ "P_SLIPTYP", "P_SLIPREF" };
				Object[] values = new Object[]
				{ new Integer(7), new Integer(myRef) };

				QueryBusinessObjects QBO = ProjectUtil.runQuery(event,
						"RECQDocs", params, values);

				if (QBO == null)
				{

					String[] enabled = new String[]
					{ "T1" };
					String[] params2 = new String[]
					{ "P_SLIPTYP" };
					Object[] values2 = new Object[]
					{ new Integer(7) };

					QueryBusinessObjects QBO2 = ProjectUtil.runQuery(event,
							"RECQDocuments", params2, values2, enabled, null);

					int ls2 = 0;
					if (QBO2 == null)
					{
						ProjectUtil.warn(event, "kayit yok");
					} else
					{
						ls2 = QBO2.size();
						for (int i = 0; i < ls2; i++)
						{
							QueryBusinessObject line = (QueryBusinessObject) QBO2
									.get(i);
							Integer DocRef = (Integer) QueryUtil
									.getIntegerProp(line, "DLOGICALREF");

							CustomBusinessObject CBO = (CustomBusinessObject) ProjectUtil
									.createNewCBO("RECODocs");
							ProjectUtil.setMemberValue(CBO, "FICHETYPE",
									new Integer(7));
							ProjectUtil.setMemberValue(CBO, "SLIPREF",
									ProjectUtil.getMemberValue(demandobj,
											"LOGICALREF"));
							ProjectUtil.setMemberValue(CBO, "DOCREF", DocRef);
							ProjectUtil.setMemberValue(CBO, "Documents.CODE",
									QueryUtil.getStringProp(line, "DCODE"));
							ProjectUtil.setMemberValue(CBO,
									"Documents.DESCRIPTION",
									QueryUtil.getStringProp(line,
											"DDESCRIPTION"));
							ProjectUtil.persistCBO(event, CBO);
						}
					}
				}

			}

			CustomBusinessObject demobj = (CustomBusinessObject) ProjectUtil
					.readObject(event, "RECOHire", myRef);
			container.openChild("Forms/RECFDocHire.lfrm", demobj, true,
					JLbsXUITypes.XUIMODE_DBUPDATE);
		}

	}

}
